#pragma once

template<class T> class zCList
{
public:
	T *data;
	zCList *next;

public:
	zCList() { data = NULL; next = NULL; }
	~zCList() { DeleteList(); }

	zVOID DeleteList()
	{
		if (data) zDELETE(data);
		if (next) zDELETE(next);
	}

	zVOID Insert(T *ins) { InsertFront(ins); }

	zVOID InsertFront(T *ins) // first element stays NULL because "this" pointer is const
	{
		zCList<T> *newItem = zNEW(zCList<T>);
		newItem->data = ins;
		newItem->next = next;
		next = newItem;
	}
};

#define zARRAY_START_ALLOC 16

template<class T> class zCArray
{
public:
	T *array;
	zINT numAlloc;
	zINT numInArray;

public:
	zCArray()
	{
		array = NULL;
		numAlloc = 0;
		numInArray = 0;
	}

	zCArray(const zINT startSize)
	{
		array = NULL;

		if (startSize > 0)
		{
			array = zNEW_ARRAY(T, startSize);
		}

		numAlloc = startSize;
		numInArray = 0;
	}

	~zCArray() { DeleteList(); }

	zVOID AllocDelta(const zINT numDelta)
	{
		if (numDelta <= 0)
		{
			return;
		}

		T *newArray = zNEW_ARRAY(T, numAlloc + numDelta);

		if (numInArray > 0)
		{
			for (int i = 0; i < numInArray; i++)
			{
				newArray[i] = array[i];
			}
		}

		zDELETE_ARRAY(array);
		array = newArray;
		numAlloc += numDelta;
	}

	zVOID AllocAbs(const zINT size)
	{
		if (numAlloc >= size)
		{
			return;
		}

		AllocDelta(size - numAlloc);
	}

	const T &operator[](const zINT nr) const { return array[nr]; }
	T &operator[](const zINT nr) { return array[nr]; }

	zVOID InsertEnd(const T &ins)
	{
		if (numAlloc < numInArray + 1)
		{
			if (numAlloc < zARRAY_START_ALLOC)
			{
				AllocDelta(zARRAY_START_ALLOC);
			}
			else
			{
				AllocDelta(numAlloc * 2);
			}
		}

		array[numInArray++] = ins;
	}

	zVOID Insert(const T &ins) { InsertEnd(ins); }

	zVOID DeleteList()
	{
		zDELETE_ARRAY(array);
		numAlloc = 0;
		numInArray = 0;
	}

	zINT Search(const T &data) const
	{
		if (numInArray > 0)
		{
			for (zINT i = 0; i < numInArray; i++)
			{
				if (array[i] == data) return i;
			}
		}

		return -1;
	}

	zBOOL IsInList(const T &data) const
	{
		if (numInArray > 0)
		{
			for (zINT i = 0; i < numInArray; i++)
			{
				if (array[i] == data) return TRUE;
			}
		}

		return FALSE;
	}

	zVOID ShrinkToFit()
	{
		if (numInArray <= 0)
		{
			DeleteList();

			return;
		}

		if (numAlloc > numInArray)
		{
			T *newArray = zNEW_ARRAY(T, numInArray);

			for (zINT i = 0; i < numInArray; i++)
			{
				newArray[i] = array[i];
			}

			zDELETE_ARRAY(array);

			array = newArray;
			numAlloc = numInArray;
		}
	}

	zVOID RemoveLast(zBOOL release = FALSE)
	{
		if (numInArray <= 0) return;

		numInArray--;

		if (release) zDELETE(array[numInArray]);
	}

	zVOID RemoveOrderIndex(const zINT index, zBOOL release = FALSE)
	{
		if (index > numInArray) return;

		if (release) zDELETE(array[index]);

		if (index != numInArray - 1)
		{
			for (zINT i = index; i < numInArray; i++)
			{
				array[i] = array[i + 1];
			}
		}

		numInArray--;
	}
};
