#include "GothicZEN.h"

zFILE::zFILE(const zSTRING &path, zBOOL write)
{
	const zCHAR *mode = (write) ? "wb" : "rb";
	this->write = write;
	file_handle = fopen(path.ToChar(), mode);
	if (!file_handle)
	{
		printf("Could not open %s, mode %s\n", path.ToChar(), mode);
		exit(zERROR);
	}
	Append();
	size = Pos();
	Reset();
}

zVOID zFILE::ReadLine(zSTRING &s)
{
	zCHAR file_buffer[zFILE_MAXCHARS + 1];
	zBOOL finished = FALSE;
	s.Clear();

	do
	{
		if (fgets(file_buffer, zFILE_MAXCHARS, file_handle) == NULL)
		{
			finished = TRUE;
		}
		else
		{
			s += zSTRING(file_buffer);

			while (s.Length() > 0 && (s.GetLastChar() == '\n' || s.GetLastChar() == '\r'))
			{
				if (s.GetLastChar() == '\n')
				{
					finished = TRUE;
				}

				s.DeleteRight(1);
			}
		}
	}
	while (!finished);
}

inline char *fgets_z(char *_Buffer, int _MaxCount, FILE *_Stream)
{
	int _Char;
	char *_Backup = _Buffer;

	for (_MaxCount--; _MaxCount > 0; _MaxCount--)
	{
		_Char = fgetc(_Stream);

		if (_Char == EOF)
		{
			*(_Buffer++) = '\0';

			break;
		}

		*(_Buffer++) = (char)_Char;

		if (_MaxCount == 1)
		{
			*_Buffer = '\0';
		}

		if (_Char == '\0')
		{
			break;
		}
	}

	return _Backup;
}

zVOID zFILE::Read(zSTRING &s)
{
	zCHAR file_buffer[zFILE_MAXCHARS];
	s.Clear();

	s += zSTRING(fgets_z(file_buffer, zFILE_MAXCHARS, file_handle));
}

zCFileBIN::zCFileBIN(const zSTRING &fname, zBOOL write)
{

	file = zNEW(zFILE)(fname, write);
	lastStart = -1;
	nextStart = -1;
}

zVOID zCFileBIN::BinOpenChunk(zWORD &id, zLONG &len)
{
	file->Read(&id, sizeof(id));

	if (file->Eof())
	{
		id = 0;
		return;
	}

	file->Read(&len, sizeof(len));

	nextStart = file->Pos() + len;
}

zVOID zCFileBIN::BinSkipChunk()
{
	if (nextStart >= file->Size())
	{
		return;
	}

	file->Seek(nextStart);
}

zVOID zCFileBIN::BinStartChunk(const zWORD id)
{
	BinEndChunk();

	zINT len = 0;
	lastStart = file->Pos();
	file->Write(&id, sizeof(id));
	file->Write(&len, sizeof(len));
}

zVOID zCFileBIN::BinEndChunk()
{
	if (lastStart != -1)
	{
		zINT actPos = file->Pos();
		zINT len = actPos - lastStart - 6;

		file->Seek(lastStart + sizeof(zWORD));
		file->Write(&len, sizeof(len));
		file->Seek(actPos);
	}
}
