#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <malloc.h>
#include <string.h>
#include <float.h>

typedef void zVOID;
typedef char zCHAR;
typedef unsigned char zBYTE;
typedef unsigned char zUINT8;
typedef int16_t zSHORT;
typedef int16_t zSWORD;
typedef uint16_t zUINT16;
typedef uint16_t zWORD;
typedef int32_t zINT;
typedef int32_t zLONG;
typedef int32_t zBOOL;
typedef int32_t zFLAGS;
typedef uint32_t zUINT;
typedef uint32_t zDWORD;
typedef uint32_t zUINT32;
typedef size_t zSIZE_T;
typedef float zREAL;
typedef float zVALUE;

#define zREAL_MAX ((zREAL)+FLT_MAX)
#define zREAL_MIN ((zREAL)-FLT_MAX)

#ifndef _WIN32
#define stricmp strcasecmp
#endif

#define FALSE 0
#define TRUE 1

#define zOK 0
#define zERROR 1

#define TEXTURE_FILE_VERSION_GOTHIC_1_01 ((zWORD)0x0000)
#define TEXTURE_FILE_VERSION_GOTHIC_1_04 TEXTURE_FILE_VERSION_GOTHIC_1_01
#define TEXTURE_FILE_VERSION_GOTHIC_1_30 ((zWORD)0x0001)

#define MESH_FILE_VERSION_GOTHIC_1_01 ((zWORD)0x0009)
#define MESH_FILE_VERSION_GOTHIC_1_04 MESH_FILE_VERSION_GOTHIC_1_01
#define MESH_FILE_VERSION_GOTHIC_1_30 MESH_FILE_VERSION_GOTHIC_1_04

#define MESH_VERSION_GOTHIC_1_01 (zWORD((TEXTURE_FILE_VERSION_GOTHIC_1_01 << 8) + MESH_FILE_VERSION_GOTHIC_1_01))
#define MESH_VERSION_GOTHIC_1_04 MESH_VERSION_GOTHIC_1_01
#define MESH_VERSION_GOTHIC_1_30 (zWORD((TEXTURE_FILE_VERSION_GOTHIC_1_30 << 8) + MESH_FILE_VERSION_GOTHIC_1_30))

#define BSP_VERSION_GOTHIC_1_01 ((zWORD)0x0001)
#define BSP_VERSION_GOTHIC_1_04 ((zWORD)0x0002)
#define BSP_VERSION_GOTHIC_1_30 ((zWORD)0x0003)

#define BSPMESH_VERSION_GOTHIC_1_01 (zDWORD((MESH_VERSION_GOTHIC_1_01 << 16) + (BSP_VERSION_GOTHIC_1_01 << 24)))
#define BSPMESH_VERSION_GOTHIC_1_04 (zDWORD((MESH_VERSION_GOTHIC_1_04 << 16) + (BSP_VERSION_GOTHIC_1_04 << 24)))
#define BSPMESH_VERSION_GOTHIC_1_30 (zDWORD((MESH_VERSION_GOTHIC_1_30 << 16) + (BSP_VERSION_GOTHIC_1_30 << 24)))

#define MATERIAL_VERSION_GOTHIC_1_01 ((zWORD)0x4400)
#define MATERIAL_VERSION_GOTHIC_1_04 MATERIAL_VERSION_GOTHIC_1_01
#define MATERIAL_VERSION_GOTHIC_1_30 ((zWORD)0x9C03)

#include "Memory.h"
#include "String.h"
#include "Container.h"
#include "Disk.h"
#include "Algebra.h"
#include "Color.h"
#include "Material.h"
#include "3D.h"
#include "Mesh.h"
#include "Bsp.h"
#include "World.h"

extern zDWORD meshAndBspVersionIn;
extern zWORD meshVersionIn;
extern zWORD bspVersionIn;
extern zWORD materialVersionIn;

extern zDWORD meshAndBspVersionOut;
extern zWORD meshVersionOut;
extern zWORD bspVersionOut;
extern zWORD materialVersionOut;

extern zBOOL xZenIn;
extern zBOOL xZenOut;

extern zBOOL deLod;
