#pragma once

class zCVob
{
public:
	zCArray<zSTRING *> lines;
};

class oCWorld
{
public:
	zCBspTree *bspTree;
	zBOOL compiled;

	zSTRING dateStr;
	zSTRING userStr;
	zSTRING objectsStr;
	zSTRING worldStr;
	zSTRING meshAndBspStr;
	zSTRING vobTreeStr;
	zSTRING vobTreeChildsStr;
	zSTRING wayNetStr;

	zCArray<zCVob *> vobTree;
	zCArray<zSTRING *> wayNet;

public:
	oCWorld() { bspTree = NULL; compiled = FALSE; }
	~oCWorld() { zDELETE(bspTree); }

	zVOID WriteHeader(zCFileBIN &file);
	zBOOL ReadHeader(zCFileBIN &file);

	zVOID ReadVobTree(zCFileBIN &file);
	zVOID ReadWayNet(zCFileBIN &file);

	zVOID WriteVobTree(zCFileBIN &file);
	zVOID WriteWayNet(zCFileBIN &file);

	zVOID WriteNewData(zCFileBIN &file, zUINT numTabs, const zSTRING &line)
	{
		for (zUINT i = 0; i < numTabs; i++)
		{
			file.BinWriteByte('\t');
		}

		file.BinWriteLine(line);
	}

	zBOOL LoadWorld(const zCHAR *fileName) { zSTRING s(fileName); return LoadWorld(s); }
	zBOOL LoadWorld(const zSTRING &fileName) { zCFileBIN f(fileName); return LoadWorld(f); }
	zBOOL LoadWorld(zCFileBIN &file);
	zBOOL SaveWorld(const zCHAR *fileName) { zSTRING s(fileName); return SaveWorld(s); }
	zBOOL SaveWorld(const zSTRING &fileName) { zCFileBIN f(fileName, TRUE); return SaveWorld(f); }
	zBOOL SaveWorld(zCFileBIN &file);
};
